#ifndef MAIN_H
#define MAIN_H
#include <QObject>
#include <QThread>
#include <QQuickWindow>
#include <QMutex>
#include <QFileSystemWatcher>

class  desktopfile : public QObject
{
  Q_OBJECT
public:
	desktopfile(QObject *p=NULL):QObject(p){  }
    desktopfile(const desktopfile &in):QObject(){name = in.name;icon = in.icon;exec = in.exec;exec_a  = in.exec_a;}
    ~desktopfile(){}
	Q_INVOKABLE void del(){deleteLater();}
	Q_PROPERTY(QString name MEMBER name)
	Q_PROPERTY(QString icon MEMBER icon)
	Q_PROPERTY(QStringList exec MEMBER exec)
	Q_PROPERTY(QStringList exec_a MEMBER exec_a)
	Q_PROPERTY(QStringList exec_js MEMBER exec_js)
	Q_PROPERTY(int display_id MEMBER display_id)
	Q_PROPERTY(QString appname MEMBER appname)
	Q_PROPERTY(int pos_x MEMBER pos_x)
	Q_PROPERTY(QString raise_app MEMBER raise_app)
	Q_PROPERTY(int issuspendbackground MEMBER issuspendbackground)
	Q_PROPERTY(QString exec_kill MEMBER exec_kill)
	Q_PROPERTY(bool exec_kill_window MEMBER exec_kill_window)
	Q_PROPERTY(int isignoretoppanel MEMBER isignoretoppanel)
	QStringList exec;
	QStringList exec_a;
	QStringList exec_js;
	QString     exec_kill;
	bool     exec_kill_window;
	QString name;
	QString icon;
	int     display_id;
	int     display_id_show;
	int     pos_x;
	QString appname;
	QString raise_app;
	bool    issuspendbackground;
	bool    isignoretoppanel;
};
Q_DECLARE_METATYPE(desktopfile)

class monitor_thread : public QThread
{
	Q_OBJECT
public:
	monitor_thread();
	void run();
	int  get_zygote_status();
	void start_zygote(bool );
	int  raise_window(const QString & winname,const QString & appname,int display_id);
	void compositor_wakeup();
	void take_screnshot();
	void delete_window(const QString & winname);
	void show_panel(bool ishow,int display_id,int height);
	void update_window_pid_info(int pid,const QString&url);
private:
	bool zygoterunning ;
	QMutex m;
public slots:
	void on_sig_zygote_running(int val);
};

class Gpqml : public QObject
{
    Q_OBJECT
    public:
    Gpqml();
    Q_INVOKABLE void set_brightness(int display_id,int value);
    Q_INVOKABLE QString get_env(const QString &);
    Q_INVOKABLE QString get_config(const QString &,const QString &);
	Q_INVOKABLE void set_prop(const QString &,const QString &);
    Q_INVOKABLE int run_process(const QString &cmd,const QString &service_name,const QString &raise_app,int display_id);
    Q_INVOKABLE int run_android_process(const QString &cmd,const QString &proc_name,const QString &raise_app,int display_id);
	Q_INVOKABLE int run_android_process_by_pkg(const QString &pkg);
    Q_INVOKABLE bool if_process_exist(const QString &pname);    
    Q_INVOKABLE QObject* create_qml_component(const QString& name);
    Q_INVOKABLE QQuickWindow* load_qml_window(const QString &name);
    Q_INVOKABLE int  get_ext_displayid();
	Q_INVOKABLE int  get_second_displayid();
	Q_INVOKABLE void sleep(int);
	Q_INVOKABLE void screenshot(QVariantList out);
	Q_INVOKABLE QVariantList load_desktop_files(int display_id);
	Q_INVOKABLE void suspend_process(int pid,bool issuspend);
	Q_INVOKABLE void kill_process(int pid);
	bool    parse_line(char *buf,char str[10][4096],int min_nb);
	QString get_project_name();
	static bool if_service_active(const QString &pname);
	static void set_property_bool(const QString &key,bool v);
	QFileSystemWatcher fw;
signals:
	void sig_zygote_running(int val);
	void sig_raise_window(const QString & winname,const QString & appname,int display_id);
	void sig_compositor_wakeup();
	void sig_take_screenshot();
    void sig_desktopfiles_changed();
	void sig_update_window_pid_info(int pid,const QString&url);					   
public slots:
	void on_directoryChanged(const QString &path);
};


#endif
