#include "nm_dbus_server.h"
#include "compositorAdaptor.h"
#include <QDBusConnection>
//#include "powermanager.h"

QDBusConnection *sconnection=NULL;

#define NM_SERVICE "org.editec.compositor"
#define NM_PATH    "/compositor"
extern QObject *root_object;

nm_dbus_server::nm_dbus_server(QObject * parent) : QObject(parent)
{
}

int nm_dbus_server::get_androidgui_status()
{
	qDebug() <<"start";
	return th->get_zygote_status();
}
void nm_dbus_server::start_androidgui(bool v)
{
	th->start_zygote(v);
}
void nm_dbus_server::compositor_wakeup()
{
	th->compositor_wakeup();
}
int  nm_dbus_server::raise_window(const QString & winname,const QString & appname,int display_id)
{
	return th->raise_window(winname,appname,display_id);
}
void nm_dbus_server::take_screenshot()
{
	th->take_screnshot();
}
void nm_dbus_server::delete_window(const QString& p)
{
	th->delete_window(p);
}
void nm_dbus_server::show_panel(const QStringList& l)
{
	int panel_height = -1;
	if (l.length() < 2)
		return;
	if (l.length() >= 3)
		panel_height = l[2].toInt();
	th->show_panel((bool)l[0].toInt(),l[1].toInt(),panel_height);
}
void nm_dbus_server::update_window_pid_info(int pid,const QString&url)
{
	th->update_window_pid_info(pid,url);
}
nm_dbus_server* nm_dbus_server_init(monitor_thread *thi)
{
	QDBusConnection *sconnection;
	CompositorAdaptor *nmA;
	nm_dbus_server *iface = NULL;

	Q_UNUSED(nmA);
	sconnection = new QDBusConnection(QDBusConnection::systemBus());
	if (!sconnection->isConnected())
		return NULL;	
	if (!sconnection->isConnected()) {	  
		qDebug() << "nm_dbus_server: Cannot connect to session bus " << sconnection->lastError().message();
		delete sconnection; sconnection = NULL;
		return NULL;
	}
	if (!sconnection->interface()->isServiceRegistered(NM_SERVICE)){
		iface = new nm_dbus_server(NULL);
		if (iface)
			iface->th = thi;
		nmA = new CompositorAdaptor(iface);
		if (!sconnection->registerService(NM_SERVICE))
		{
			qFatal("Could not register service!");
			delete nmA;delete iface;
			return NULL;
		}
		if (!sconnection->registerObject(NM_PATH, iface))
		{
			qFatal("Could not register air object! %s",sconnection->lastError().message().toUtf8().data());
			delete nmA;delete iface;
			return NULL;
		}
	}
	qDebug() << "org.editec.compositor dbus service is registered";
	return iface;
}
